/****************************************************************************
 **
 ** Copyright (C) 2008-2009 Grigory A. Mozhaev.  All rights reserved.
 **
 ** This file may be used under the terms of the GNU General Public
 ** License version 2.0 as published by the Free Software Foundation
 ** and appearing in the file LICENSE.GPL included in the packaging of
 ** this file.  Please review the following information to ensure GNU
 ** General Public Licensing requirements will be met:
 ** http://www.trolltech.com/products/qt/opensource.html
 **
 ** If you are unsure which license is appropriate for your use, please
 ** review the following information:
 ** http://www.trolltech.com/products/qt/licensing.html or contact the
 ** sales department at sales@trolltech.com.
 **
 ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
 ** AUTHOR: Grigory A. Mozhaev <zcrendel@mail.ru>
 **
 ****************************************************************************/
#ifndef __CAPPLICATION_H__
#define __CAPPLICATION_H__

#include <QtCore>
#include <QtGui>
#include <QtXml>

#include <CGlobals>

class CApplication : public QApplication {
Q_OBJECT

public:
    CApplication(int &, char **);
    ~CApplication();

    int init();

    static QSettings *settings();
    static CGlobals  *globals();

#ifdef HAVE_GUI
    static void storeWidgetStatus (const QString &aName, QWidget *aWidget,
                            const QMap<QString, QVariant> *aOptions = 0);

    static void restoreWidgetStatus (const QString &aName, QWidget *aWidget,
                              const QMap<QString, QVariant> *aOptions = 0);
#endif // HAVE_GUI

private:
    QString initCommandArgs(); // return path to configuration file or QString::null
    void    initDependsOnSystem();

    void initLocale();
    void initSettings(const QString &aConfigFileName = QString::null,
                      QSettings::Format aFormat = QSettings::NativeFormat);
    void initGlobals();
    void initTranslation();

    static QSettings    *mpSettings;
    static CGlobals     *mpGlobals;
    static QTranslator  *mpTranslator;
};

#endif // __CAPPLICATION_H__
