/****************************************************************************
 **
 ** Copyright (C) 2008-2009 Grigory A. Mozhaev.  All rights reserved.
 **
 ** This file may be used under the terms of the GNU General Public
 ** License version 2.0 as published by the Free Software Foundation
 ** and appearing in the file LICENSE.GPL included in the packaging of
 ** this file.  Please review the following information to ensure GNU
 ** General Public Licensing requirements will be met:
 ** http://www.trolltech.com/products/qt/opensource.html
 **
 ** If you are unsure which license is appropriate for your use, please
 ** review the following information:
 ** http://www.trolltech.com/products/qt/licensing.html or contact the
 ** sales department at sales@trolltech.com.
 **
 ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
 ** AUTHOR: Grigory A. Mozhaev <zcrendel@mail.ru>
 **
 ****************************************************************************/

#include <QtCore>
#include <QObject>
#include <QFile>
#include <QFileInfo>
#include <QDir>
#include <QString>

class CFsUtils : public QObject {
Q_OBJECT

public:
    CFsUtils() {};
    
    enum { 
        ECODE_SUCCESS = 0,
        ECODE_FILE_CREATE = 1,
        ECODE_FILE_OPEN = 2,
        ECODE_FILE_CLOSE = 3,
        ECODE_FILE_READ = 4,
        ECODE_FILE_WRITE = 5,
        ECODE_FILE_COPY = 6,
        ECODE_FILE_REMOVE = 7,
        ECODE_FILE_RENAME = 8,
        ECODE_DIR_CREATE = 9,
        ECODE_DIR_REMOVE = 10,
        ECODE_DIR_RENAME = 11,
        ECODE_DIR_COPY = 12,
        ECODE_NAME_ISNT_DIR = 13,
        ECODE_NAME_ISNT_FILE = 14,
        ECODE_WRONG_PATH = 15,
        ECODE_EXTRACT = 16,
        ECODE_COMPRESS = 17,
        ECODE_DUMMY = 18
    };

    static int getFilesDirsLists(const QString &aRootDir,
                                 QStringList &aDirectories, QStringList &aFiles,
                                 bool aStripRoot = false);

    static int removeDirectory(const QString &aDirName);
    
    static int copyDirectory(const QString &aFromPath, const QString &aToPath,
                             bool  aOnlyContent = false);

    static int extractZipFile(const QString &aFileName,   const QString &vWorkDir);

    static int compressZipFile(const QString &aFileName,  const QString &vWorkDir);

    /** содержит словесное описание ошибки,
     * в случае если одна из следующих функций вернула код != 
     * ECODE_SUCCESS:
     * getFilesDirsLists, removeDirectory, copyDirectory, ...
     *
     */
    static QString        mErrorMessage;
};

