/****************************************************************************
 **
 ** Copyright (C) 2008-2009 Grigory A. Mozhaev.  All rights reserved.
 **
 ** This file may be used under the terms of the GNU General Public
 ** License version 2.0 as published by the Free Software Foundation
 ** and appearing in the file LICENSE.GPL included in the packaging of
 ** this file.  Please review the following information to ensure GNU
 ** General Public Licensing requirements will be met:
 ** http://www.trolltech.com/products/qt/opensource.html
 **
 ** If you are unsure which license is appropriate for your use, please
 ** review the following information:
 ** http://www.trolltech.com/products/qt/licensing.html or contact the
 ** sales department at sales@trolltech.com.
 **
 ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
 ** AUTHOR: Grigory A. Mozhaev <zcrendel@mail.ru>
 **
 ****************************************************************************/
#ifndef __CGLOBALS_H__
#define __CGLOBALS_H__

#include <QMap>
#include <QString>
#include <QVariant>

typedef QMap<QString,QVariant> CValuesMap;

//!
class CGlobals {
public:
    CGlobals();
    ~CGlobals();

    void setValue(const QString &aKey, const QVariant &aValue);
    QVariant value(const QString &aKey, const QVariant &aDefaultValue = QVariant()) const;
    QVariant constant(const QString &aKey, const QVariant &aDefaultValue = QVariant()) const;

private:
    CValuesMap mVariables;
    CValuesMap mConstants;
};

#endif // __CGLOBALS_H__
