/****************************************************************************
 **
 ** Copyright (C) 2008-2009 Grigory A. Mozhaev.  All rights reserved.
 **
 ** This file may be used under the terms of the GNU General Public
 ** License version 2.0 as published by the Free Software Foundation
 ** and appearing in the file LICENSE.GPL included in the packaging of
 ** this file.  Please review the following information to ensure GNU
 ** General Public Licensing requirements will be met:
 ** http://www.trolltech.com/products/qt/opensource.html
 **
 ** If you are unsure which license is appropriate for your use, please
 ** review the following information:
 ** http://www.trolltech.com/products/qt/licensing.html or contact the
 ** sales department at sales@trolltech.com.
 **
 ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
 ** AUTHOR: Grigory A. Mozhaev <zcrendel@mail.ru>
 **
 ****************************************************************************/
#ifndef _CHIGHLIGHTER_H_
#define _CHIGHLIGHTER_H_

#include <QSyntaxHighlighter>

#include <QHash>
#include <QTextCharFormat>

class CHighlighter : public QSyntaxHighlighter
{
    Q_OBJECT

public:
    CHighlighter(QTextDocument *apParent = 0);

protected:
    void highlightBlock(const QString &aText);

private:
    struct SRule  {
        QRegExp mPattern;
        QTextCharFormat mFormat;
    };
    QVector<SRule> mRules;

    QRegExp mCommentStart;
    QRegExp mCommentEnd;

    QTextCharFormat mKeyword;
    QTextCharFormat mSingleLineComment;
    QTextCharFormat mMultiLineComment;
    QTextCharFormat mQuotation;
    QTextCharFormat mFunction;
};

#endif // _CHIGHLIGHTER_H_
