/****************************************************************************
 **
 ** Copyright (C) 2008-2009 Grigory A. Mozhaev.  All rights reserved.
 **
 ** This file may be used under the terms of the GNU General Public
 ** License version 2.0 as published by the Free Software Foundation
 ** and appearing in the file LICENSE.GPL included in the packaging of
 ** this file.  Please review the following information to ensure GNU
 ** General Public Licensing requirements will be met:
 ** http://www.trolltech.com/products/qt/opensource.html
 **
 ** If you are unsure which license is appropriate for your use, please
 ** review the following information:
 ** http://www.trolltech.com/products/qt/licensing.html or contact the
 ** sales department at sales@trolltech.com.
 **
 ** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 ** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 **
 ** AUTHOR: Grigory A. Mozhaev <zcrendel@mail.ru>
 **
 ****************************************************************************/
#ifndef __IREPORTPLUGIN_H__
#define __IREPORTPLUGIN_H__

#include <QString>
#include <QStringList>
#include <IReport>

class IReportPlugin {
public:
    virtual ~IReportPlugin() = 0;
    virtual IReport *create() = 0;
    virtual QString  name() = 0;
    virtual QString  version() = 0;
};

Q_DECLARE_INTERFACE(IReportPlugin, "IReportPlugin/1.0")

#endif // __IREPORTPLUGIN_H__
